/*--PSEUDO-CODE--*/

if(locale('ru')){
  var $home='Главная';
  var $profile='Профиль';
  var $editor='Редактор';
  var $logout='Выход';
  var $logoutConfirm='Выйти из системы?';
  var $logoutText='Ваша сессия на данном устройстве будет завершена';
  var $yeslogout='Да, выйти';
  var $noaccess='Нет доступа';
  var $error='Ошибка';
  var $version='Версия';
  var $based_on="На платформе <a href='https://pult.online'>Пульт.Онлайн</a>";
  var $sound_on='Звук включен';
  var $sound_off='Звук отключен';
  var $notifications='Уведомления';
  var $new_notifications='Новые уведомления';
  var $system='Система';
  var $events='Аварии и события';
  var $noevents='Нет актуальных событий';
  var $more_events1='+ еще %s актуальное событие';
  var $more_events2='+ еще %s актуальных события';
  var $more_events5='+ еще %s актуальных событий';
  var $anonymous_login = "Войти в систему";
  var $made_with_pult_online="На платформе <a href='https://pult.online'>Пульт.Онлайн</a>";
  var $sound_disabled="Звук отключен";
  var $sound_reset="Звук сброшен до следующего события";
  var $sound_click_for_disable="Нажмите еще раз для отключения";
  var $refresh="Обновить";
  var $edit_object="Редактировать объект";
  var $alarm_sound="Звук аварий";
  var $search_by_part='Поиск в текущем разделе';
  var $search_by_projects='Поиск в проектах';
  var $found='Найдено в "${here}": ${count}';
  var $found_in_projects='Найдено в проектах: ${count}';
  var $found_first='Показана первая %s результатов';
  var $find='Найти';
  var $search='Поиск по разделам проектов';
  var $search_help='Поиск по именам разделов<br>Например: <em>щув 123</em>';
  var $refresh_after_build="Страница обновлена после Сборки";
  
}else{
  var $profile='Profile';
  var $editor='Editor';
  var $logoutConfirm='Are you sure you want to logout?';
  var $logoutText='Your session on this device will be finished';
  var $yeslogout='Yes, logout';
  var $home='Home';
  var $logout='Logout';
  var $noaccess='Access denied';
  var $error='Error';
  var $version='Version';
  var $sound_on='Sound enabled';
  var $sound_off='Sound disabled';
  var $based_on="Powered by <a href='https://pult.online'>Pult.Online</a>";
  var $system='Система';
  var $events='Alarms and Events';
  var $noevents='No actual events';
  var $more_events1='+%s more actual events';
  var $more_events2='+%s more actual events';
  var $more_events5='+%s more actual events';
  var $notifications='Notifications';
  var $new_notifications='New notifications';
  var $anonymous_login = "Log in";
  var $made_with_pult_online="Made with <a href='https://pult.online/en'>Pult.Online</a>";
  var $sound_disabled="Sound disabled";
  var $sound_reset="Sound reset until next event";
  var $sound_click_for_disable="Click again to disable";
  var $refresh="Refresh";
  var $edit_object="Edit object";
  var $alarm_sound="Alarm sound";
  var $search_by_part='Search in current location';
  var $search_by_projects='Search in projects';
  var $found='Found in "${here}": ${count}';
  var $found_in_projects='Found in projects: ${count}';
  var $found_first='First %s results shown';
  var $find='Find';
  var $search_help='Search by section names<br>For example: <em>fcu 123</em>';
  var $refresh_after_build="Page reloaded after Building";

}


TEMPLATE = createTemplate(
	`:host {
  display: block;
  position: relative;
  width: 100%;
  height: 100%;
}
* {
  box-sizing: border-box;
  scrollbar-width: thin;
  scrollbar-color: var(--anode-scroll-handle-color) var(--anode-scroll-background-color);
}
*::-webkit-scrollbar {
  width: 10px;
  height: 10px;
}
*::-webkit-scrollbar-thumb {
  border-style: solid;
  border-width: 1px;
  border-radius: 3px;
}
* ::-webkit-scrollbar-track {
  background-color: var(--anode-scroll-background-color);
}
* ::-webkit-scrollbar-thumb {
  background-color: var(--anode-scroll-handle-color);
  border-color: var(--anode-scroll-background-color);
}
* ::-webkit-scrollbar-corner {
  background-color: var(--anode-scroll-background-color);
}
#body {
  display: flex;
  flex-direction: column;
  flex-wrap: nowrap;
  position: relative;
  width: 100%;
  height: 100%;
}
#body.mobile {
  overflow: hidden;
  position: fixed;
}
#body.mobile #layout1 {
  width: 300vw !important;
  transition: 0.1s left;
}
#body.mobile #layout1::part(splitter) {
  display: none;
}
#body.mobile #left,
#body.mobile #mid,
#body.mobile #right {
  flex: 0 0 100vw !important;
}
#body.mobile .panel .header {
  height: 40px;
}
#body.mobile .panel .header a-icon {
  width: 24px;
  height: 24px;
}
#body.mobile #left_icon {
  height: 40px;
  width: 40px;
}
#body.mobile #left_icon svg {
  display: block;
  position: absolute;
  width: 24px;
  height: 18px;
  margin-left: -12px;
  margin-top: -9px;
}
#body.mobile.left_closed.right_closed #layout1 {
  left: -100vw;
}
#body.mobile:not(.left_closed) #layout1 {
  left: 0vw;
}
#body.mobile:not(.right_closed) #layout1 {
  left: -200vw;
}
#body.mobile #menu {
  --line-height: 32px;
}
#body.mobile #home > div {
  display: none;
}
#header {
  display: flex;
  flex-direction: row;
  padding-left: 10px;
  transition: 0.1s padding;
}
#body.left_closed.menu #header {
  padding-left: 40px;
}
#body.mobile.left_closed.menu #header {
  padding-left: 50px;
}
#header a {
  color: var(--app-topline-text-color);
}
#header a:hover {
  color: var(--app-topline-active-text-color);
}
.header_block {
  display: flex;
  flex-direction: row;
}
#sound {
  margin-left: 5px;
}
#clock {
  position: relative;
  top: -1px;
}
#refresh {
  color: var(--app-header-button-text-color) !important;
}
#refresh a-icon {
  animation: refresh_rotation 1s linear infinite;
  --color: var(--app-header-button-text-color) !important;
}
#refresh:hover {
  color: var(--app-topline-active-text-color) !important;
}
#refresh:hover a-icon {
  --color: var(--app-topline-active-text-color) !important;
}
#home,
#refresh,
#editor_link {
  display: flex;
  flex-direction: row;
  align-items: center;
  color: var(--app-topline-text-color);
  position: relative;
  top: -1px;
}
#home div,
#refresh div,
#editor_link div {
  margin-left: 4px;
}
#home:hover,
#refresh:hover,
#editor_link:hover {
  color: var(--app-topline-active-text-color);
}
#home:hover a-icon,
#refresh:hover a-icon,
#editor_link:hover a-icon {
  --color: var(--app-topline-active-text-color);
}
#editor_link {
  margin-left: 12px;
  padding-left: 12px;
  border-left: solid 1px var(--app-topline-separator-color);
}
#editor_link a-icon {
  position: relative;
  top: -1px;
}
@keyframes refresh_blink {
  0% {
    opacity: 0.3;
  }
  49% {
    opacity: 0.3;
  }
  50% {
    opacity: 1;
  }
  100% {
    opacity: 1;
  }
}
@keyframes refresh_rotation {
  0% {
    transform: rotate(0deg);
  }
  100% {
    transform: rotate(360deg);
  }
}
#breadcrumbs {
  position: relative;
  top: -1px;
  margin-left: 12px;
  padding-left: 12px;
  border-left: solid 1px var(--app-topline-separator-color);
  overflow: hidden;
  white-space: nowrap;
  text-overflow: ellipsis;
}
#breadcrumbs a {
  color: var(--app-topline-text-color);
  text-decoration: none;
}
#breadcrumbs a:hover {
  color: var(--app-topline-active-text-color);
}
#notification_link,
#alarm_link {
  white-space: nowrap;
}
#notification_link span,
#alarm_link span {
  padding-left: 20px;
}
#notification_link:hover a-badge,
#alarm_link:hover a-badge,
#notification_link:hover a-alarm-badge,
#alarm_link:hover a-alarm-badge {
  --text-color: var(--app-topline-active-text-color) !important;
  --active-border-color: var(--app-topline-active-text-color) !important;
  --active-text-color: var(--app-topline-active-text-color) !important;
}
#layout1 {
  width: 100%;
  height: 100%;
}
#left_icon {
  width: 35px;
  height: 32px;
  position: absolute;
  top: 0px;
  transition-property: left,right;
  transition-duration: 0.1s;
  background-color: var(--app-topline-color);
  cursor: pointer;
}
#left_icon svg {
  display: block;
  position: absolute;
  width: 16px;
  height: 12px;
  margin-left: -8px;
  margin-top: -6px;
  left: 50%;
  top: 50%;
}
#left_icon svg path {
  fill: var(--app-topline-text-color);
}
#left_icon svg:active path,
#left_icon svg:hover path {
  fill: var(--app-topline-active-text-color);
}
#left_icon {
  cursor: pointer;
  left: 0px;
}
a-badge,
a-alarm-badge {
  display: inline-block;
  vertical-align: middle;
  --background-color: var(--app-control-color);
  --border-color: var(--app-control-color);
  --font-size: 14px;
  --padding: 1px 8px;
  --border-radius: 3px;
  position: relative;
  top: -1px;
}
#left,
#mid,
#right {
  overflow: hidden;
  display: flex;
  flex-direction: column;
}
#mid {
  background-color: var(--app-background-color);
}
.panel {
  position: relative;
  background-color: var(--app-panel-color);
}
.panel .header {
  padding-top: 4px;
  padding-right: 10px;
  overflow: hidden;
  display: flex;
  flex-direction: row;
  justify-content: space-between;
  align-items: center;
  height: 33px;
  flex-shrink: 0;
  box-sizing: border-box;
  border-bottom: solid 1px var(--app-topline-border-color);
  background-color: var(--app-topline-color);
  color: var(--app-topline-text-color);
  white-space: nowrap;
}
.panel .header a-icon {
  width: 16px;
  height: 16px;
  position: relative;
  vertical-align: middle;
  top: -2px;
  --color: var(--app-topline-text-color);
  cursor: pointer;
  user-select: none;
}
.panel .header a-icon:hover {
  --color: var(--app-topline-active-text-color);
}
.panel .center {
  display: flex;
  flex-direction: column;
  flex-grow: 1;
  overflow: hidden;
}
#brand {
  display: none;
  flex-direction: row;
  padding: 5px 45px 5px 15px;
  min-height: 48px;
  white-space: nowrap;
  align-items: center;
  overflow: hidden;
  flex-shrink: 0;
}
#brand_link {
  display: inline-block;
}
#brand_text {
  margin-top: 5px;
}
#brand_logo {
  display: block;
}
#profile.selected {
  background-color: var(--app-selected-color);
}
#anonymous_login {
  display: inline-block;
  color: var(--app-header-link-color);
  text-decoration: none;
}
#anonymous_login:hover {
  color: var(--app-header-link-hover-color);
}
#anonymous_login:hover a-icon {
  --color: var(--app-header-link-hover-color);
}
#anonymous_login a-icon {
  --color: var(--app-header-link-color);
  width: 16px;
  height: 16px;
  vertical-align: middle;
}
#anonymous_login div {
  vertical-align: middle;
  position: relative;
  top: 2px;
  display: inline-block;
}
#left_title,
#mid_title,
#right_title {
  line-height: 32px;
  white-space: nowrap;
  padding: 0px 10px;
  font-size: 12px;
  text-transform: uppercase;
}
#left_title {
  padding: 0px;
}
#menu {
  --background-color: var(--app-panel-color);
  --selected-background-color: var(--app-selected-color);
  padding-bottom: 20px;
  width: auto;
  overflow: auto;
  height: 100%;
}
#ntfbar {
  --button-hover-color: transparent;
}
#right_center {
  position: relative;
  display: flex;
  flex-direction: column;
  overflow: hidden;
}
#ntftop {
  position: absolute;
  width: 100%;
  z-index: 100;
}
#ntfwrp {
  flex-shrink: 0;
  text-align: center;
  border-bottom: solid 1px var(--app-control-color);
  padding: 0px 10px;
  height: 0px;
  opacity: 0;
  overflow: hidden;
}
#ntfwrp._active {
  opacity: 1;
  height: 47px;
}
#ntfwrp a-button {
  margin: 8px 0px 10px 0px;
  width: 100%;
}
#ntfwrp a-progress {
  margin: 0px -10px;
}
#ntflist {
  overflow: auto;
  padding: 10px;
}
#ntflist > div {
  border-bottom: solid 1px var(--app-control-color);
  padding: 10px 10px;
}
#ntflist > div > div:first-child {
  font-size: 12px;
  margin-bottom: 5px;
  white-space: pre-wrap;
}
#ntflist > div > div:nth-child(2) {
  font-size: 11px;
  color: var(--app-comment-color);
}
#ntflist > div.ntf_type_0 {
  color: var(--app-error-color);
}
#ntflist > div.ntf_border {
  border-bottom: solid 2px var(--app-selected-color);
}
.ntf_new {
  animation-name: key_ntf_new;
  animation-duration: 1s;
  animation-iteration-count: 1;
}
#navigation {
  position: relative;
  height: 100%;
  overflow: hidden;
}
#btn_search {
  position: absolute;
  right: 10px;
  bottom: 12px;
  height: 24px;
}
.nav_icon {
  width: 24px;
  height: 24px;
  padding: 4px;
  cursor: pointer;
  user-select: none;
  flex-shrink: 0;
  --color: var(--app-text-color);
}
.nav_icon:hover {
  --color: var(--app-active-text-color);
}
#search {
  display: flex;
  flex-direction: column;
}
#search_header {
  display: flex;
  flex-direction: row;
  padding: 10px;
  flex-shrink: 0;
  flex-grow: 0;
  background-color: var(--app-header-color);
}
#search_header a-icon {
  padding: 6px;
  margin-left: 5px;
  margin-right: -5px;
}
#search_header a-button {
  flex-shrink: 0;
  margin-left: 10px;
}
#search_input {
  max-width: 100%;
}
#search_info {
  padding: 10px;
  color: var(--app-comment-color);
}
#search_list {
  display: flex;
  flex-direction: column;
  overflow: hidden;
  height: 100%;
  border-bottom: solid 1px var(--app-header-border-color);
}
#search_items {
  height: 100%;
  overflow: auto;
}
#search_items div {
  border-top: solid 1px var(--app-control-color);
  white-space: nowrap;
  padding: 6px 10px;
}
#search_items div a a-icon {
  width: 16px;
  height: 16px;
  vertical-align: middle;
  position: relative;
  top: -2px;
}
#search_items div span {
  display: block;
  color: var(--app-comment-color);
  font-size: var(--app-small-font-size);
  margin-bottom: 3px;
}
@keyframes key_ntf_new {
  0% {
    color: var(--app-active-text-color);
  }
  100% {
    color: var(--app-text-color);
  }
}
/*# sourceMappingURL=_style.css.map */`,
	`<div id="body">
	<a-layout id='layout1' stretch='slot2' size1=220 store=true allow_mobile="false">
		
		<!-- LEFT -->

		<div id='left' class='panel' slot='1' style="display: none;">
			<a-button id="btn_search" focusable="false" title="${$search}" icon="/images/search.svg"></a-button>
			<div class="header">
				<div id='left_title'></div>
				<div>
					<a-clock id='clock'></a-clock>
					<a-icon id="btn_sound" title="${$alarm_sound}" src="/images/sound_off.svg"></a-icon> 
				</div>
			</div>
			<div class="center">
				<div id="profile" class="pult_header">
					<div id="profile_title" class="pult_name">
						<a id="profile_link" href="">
							<a-icon id="profile_icon"></a-icon> 
							<div id="profile_text"></div>
						</a>
					</div>
					<a id="anonymous_login" href="#interface/login">
					<a-icon src="/images/login.svg"></a-icon> <div>${$anonymous_login}</div>
					</a>  
				</div>
				<a-layout   id='layout_nav' allow_mobile="false" orientation='vertical' stretch='slot1' store="true" size2=300 store="true" default_closed="2">
					<div slot="1" id="navigation">
						<a-dtree id='menu' ></a-tree>
					</div>	
					<div slot="2" id="search">
						<div id="search_header">
							<a-input id="search_input" clear_button="true"></a-input>
							<a-button id="search_button" disabled="true" title="${$find} (Enter)" caption="${$find}"></a-button>
							<!-- <a-icon id="search_close_button" class="nav_icon" src="/images/close.svg" title="${$close}"></a-icon> -->
						</div>
						<div id="search_list">
							<div id="search_info"></div>
							<div id="search_items"></div>
						</div>
					</div>	
				</a-layout>
			</div>	
			<div class="bottom" id="brand">
				<a id="brand_link"><img id="brand_logo"></a>
				<div id="brand_text"></div>
			</div>			
		</div>

		<a-layout   id='layout2' slot='2' stretch='slot1' size2=220 store=true default_closed=2 allow_mobile="false">


			<!-- MID -->

			<div id="mid" slot="1"  class='panel' >
				<div id="header"  class="header" style="display: none;">
					<div class="header_block">
						<a id="home" href="#">
							<a-icon src="/images/home.svg"></a-icon>
							<div>${$home}</div>
						</a>
						<a id="refresh" href="javascript:void(0)" style="display:none">
							<a-icon src="/images/refresh.svg"></a-icon>
							<div>${$refresh}</div>
						</a>
						<a href="" id="editor_link" title="${$edit_object}" target="editor">
							<a-icon src="/images/editor.svg"></a-icon>
							<!-- <div>${$editor}</div> -->
						</a>

						<div id="breadcrumbs"></div>
					</div>

					<div class="header_block">
						<a href="#interface/alarms?path=/projects" id="alarm_link">
							<span>${$alarms}</span>
							<a-alarm-badge id='alarm_badge' class="alarm_badge" max_value="999"></a-alarm-badge>
						</a>
						<a href="javascript:void(0)" id="notification_link">
							<span>${$notifications}</span>
							<a-badge id='notification_badge'  max_value="999"></a-badge>
						</a>
					</div>

				</div>
				<a-widget id='main_widget' slot="1"></a-widget>
			</div>

			
			<!-- RIGHT -->

			<div id='right' class='panel' slot='2' style="display: none;">
				<div class="header">
					<div></div>
					<a-icon id="right_close" src="/images/close.svg"></a-icon>
				</div>
				<div id="right_center" class="center">
					<div id='ntftop'>
					<a-progress id='ntfprogress'></a-progress>
					<a-message id='ntferror'></a-message>
					</div>
					<div id='ntftitle' class="pult_header">
					<div class="pult_name">
						<a href="">
							<a-icon src="/images/notifications.svg"></a-icon> 
							<div>${$notifications}</div>
						</a>
					</div>
					</div>
					<div id='ntfwrp'>
					<a-button id='ntfbtn' caption='' palette='anode-button-active'></a-button>
					</div>
					<div id='ntflist'></div>
				</div>
				<div class="bottom" ></div>
			</div>

		</a-layout>

	</a-layout>

	<!-- ICONS -->

	<div id='left_icon' style="display: none;">
		<svg height="12" viewBox="0 0 16 12" width="16" xmlns="http://www.w3.org/2000/svg"><path d="m0 0v2h16v-2zm0 5v2h16v-2zm0 5v2h16v-2z" stroke-width="1.224745"/></svg>
	</div>
	
</div>	`,
);

let sub_refresh;
let parent,menu;

PROPERTIES={
	path:{
		type:'string',
		default:'/projects'
	},
	breadcrumbs:{
		type:'object',
		propagate:false,
	},
	editor_link:{
		type:'string',
		propagate:false,
		default:'',
	},
};


ONCREATE=function(){
	document.getElementById("favicon").href=config.brand_icon;
	window.name = 'interface';
	parent=self.parentNode.host;
	menu=dom.menu;
	menu.css=`.online>.title>.link>.text{color:var(--app-online-color)}.online>.title>.link>a-icon{--color:var(--app-online-color)}.online>.title>.link:hover>.text{color:var(--app-link-hover-color)}.online>.title>.link:hover>a-icon{--color:var(--app-link-hover-color)}.offline>.title>.link>.text{color:var(--app-offline-color)}.offline>.title>.link>a-icon{--color:var(--app-offline-color)}.offline>.title>.link:hover>.text{color:var(--app-link-hover-color)}.offline>.title>.link:hover>a-icon{--color:var(--app-link-hover-color)}`;
	parent.addEventListener('change',cbWorkspaceSrcChanged);
	cbWorkspaceSrcChanged();
	prepareHTML();
	prepareMenu();
	loadMenu();
	pult.metronom.listen(onMetronom,5);
	pult.events.listen('user_alarms',update_user_alarms);

	setTimeout(function (){
		pult.sound.init({
			checkSoundFile:'/sound/check.mp3',
			showErrorEachEnable:false,
			onError:function (msg){
				pult.showInfo(self,locale_string(msg));
			}
		});

		pult.sound.reset=false;
		
		refreshSoundButton();
		
		dom.btn_sound.onclick=function (){
			if(pult.sound.enabled){
				if(pult.sound.reset || !pult.userAlarms?.total?.au[0]){
					pult.showTooltip(self,$sound_disabled);
					pult.sound.toggle(); // off
				}else{
					pult.showTooltip(self,$sound_reset,null,1500);
					pult.sound.reset=true;
					if(!self.___firstSoundReset){
						self.___firstSoundReset=true;
						setTimeout(function (){
							pult.showTooltip(self,$sound_click_for_disable);
						},1600);
					}
				}
			}else{
				pult.sound.reset=false;
				pult.sound.toggle(); // on
			}
			refreshSoundButton();
		}

		update_user_alarms();
		
	},300);

	dom.refresh.onclick=function (e){
		location.reload();
	}

	dom.layout_nav.onswap=function (e){
		refreshSearch();
	}

	dom.btn_search.onclick=function (e){
		if(dom.layout_nav.closed==2){
			dom.layout_nav.closed=0;
			dom.search_input.set_focus=true;
		}else{
			dom.layout_nav.closed=2;
		}
		refreshSearch();
	}

	// dom.search_close_button.onclick=function (){
	// 	dom.layout_nav.closed=2;
	// }

	refreshSearch();

	dom.search_info.innerHTML=$search_help;

	dom.search_input.onchange=function (e){
		let search=e.detail;
		dom.search_button.disabled=!search;
		if(!search){
			dom.search_info.innerHTML=$search_help;
			dom.search_items.innerHTML='';
		}
	}

	dom.search_input.onkeypress=function (e){
		if(e.key==='Enter'){
			dom.search_button.onclick();
		}
	}

	dom.search_button.onclick=function (){
		let search=dom.search_input.value;
		dom.search_info.innerHTML='';
		dom.search_items.innerHTML='';
		if(search){

			let hash_params=aWidget.getParams(parent.src);
			let here=self?.breadcrumbs[self.breadcrumbs.length-1]?.[0];
			let path=hash_params?.path ?? '/projects';
			pult.request(self,'fdb_search',{
				path:path,
				search:search
			},function (req,res,err){
				if(err){
					pult.showError(self,err);
				}else{
					console.log(here,res);

					let list=res.list;
					let count=res.list.length;
					let more=res.more;

					for(let i=0; i<count; i++){
						list[i]=pult.fdb.unpack(list[i],null,'@prop.json');
					}

					Util.keySort(list,'_path');

					if(path==='/projects'){
						dom.search_info.innerHTML=Util.format($found_in_projects,{count:(more?'>':'')+count});
					}else{
						dom.search_info.innerHTML=Util.format($found,{count:(more?'>':'')+count,here:here});
					}
					
					let pl=path.split('/').length-2;
					let a=[];
					for(let i=0; i<count; i++){
						let o=list[i];
						let pp=pult.getPseudoPath(o._path,undefined,pl);
						a.push(
							`<div>
								<span>${pp}</span>
								<a href='${o._interface}'><a-icon src='${o._icon}'></a-icon> ${o._title}</a>
							</div>`
						);
					}
					if(more){
						a.push(
							`<div class='comment'>${Util.format($found_first,more)}</div>`
						);
					}
					dom.search_items.innerHTML=a.join('');

				}
			});
		}
	}

	sub_refresh=pult.subscribe('refresh_interface',null,function (s,p){
		if(!p?.error){
			if(config.force_refresh_interface){
				sessionStorage.refreshAfterBuild=1;
				location.reload();
			}else{
				showRefresh();
			}
		}
	});
	

	
	self.___custo.disconnect();
	self.___custo=null;

	//console.log('create',self.tagName);
	self.___custo=pult.observeCustomElements(self,self.container,[
		//{tag:'body',observeChildren:true},
		{tag:'div',observeChildren:true},
		{tag:'a-layout',observeChildren:true},
		{tag:'a-widget',observeShadowRoot:true},
		// {prefix:'control-common-rect',observeChildren:true},
		
		{prefix:'widget-',observeShadowRoot:false},
	]);
	//console.log(self.___custo);

	if(sessionStorage.refreshAfterBuild){
		sessionStorage.removeItem('refreshAfterBuild');
		pult.showTooltip(self,$refresh_after_build);
	}

}

ONDESTROY=function(){
	parent.removeEventListener('change',cbWorkspaceSrcChanged);
	pult.metronom.unlisten(onMetronom);
	pult.events.unlisten('user_alarms',update_user_alarms);
	pult.unsubscribe(sub_refresh);
	pult.unsubscribeStatusVar(self);
	self.___custo.disconnect();
}


ONUPDATE=function(changes){
	for(let k in changes){
		if(k==='breadcrumbs') update_breadcrumbs();
		if(k==='editor_link') update_editor_link();
	}
}

function refreshSearch(){


	if(dom.layout_nav.closed==2){
		dom.btn_search.palette='';
	}else{
		let params=aWidget.getParams(parent.src);
		if(params?.path){
			dom.search_input.placeholder=$search_by_part;
		}else{
			dom.search_input.placeholder=$search_by_projects;
		}
		dom.btn_search.palette='anode-button-checked';
	}

}

function showRefresh(){
	dom.refresh.style.display='flex';
	dom.home.style.display='none';
}

function refreshSoundButton(){
	if(pult.sound.enabled){
		dom.btn_sound.src='/images/sound_on.svg';
		dom.btn_sound.caption=$sound_on;
	}else{
		dom.btn_sound.src='/images/sound_off.svg';
		dom.btn_sound.caption=$sound_off;
	}
}

function update_editor_link(){
	if(self.__editor_link && !pult.isMobile){
		dom.editor_link.style.display='flex';
		dom.editor_link.href=self.__editor_link;
	}else{
		dom.editor_link.style.display='none';
		dom.editor_link.href="";
	}
}

function update_user_alarms(){
	let self=this;

	//console.log('update_user_alarms');
	dom.alarm_badge.animation=1;
	dom.alarm_badge.value=pult.userAlarms.summary.count;
	dom.alarm_badge.cls=pult.userAlarms.summary.class;
	dom.alarm_badge.active=pult.userAlarms.summary.active;
	dom.alarm_badge.unack=pult.userAlarms.summary.unack;
	dom.alarm_badge.blink=pult.userAlarms.summary.actunack;

	let changes=pult.userAlarms.changes;
	updateTreeBadges(changes);
	
}

function updateTreeBadges(objects){
	for(let k in objects){
		let o=objects[k];
		let s=o.au[0]+o.aa[0]+o.iu[0];
		if(s){

			let cls=0;
			if(cls < o.iu[1]) cls=o.iu[1];
			if(cls < o.aa[1]) cls=o.aa[1];
			if(cls < o.au[1]) cls=o.au[1];

			if(cls===4) clr='var(--app-alm-alarm-text-color)';
			if(cls===3) clr='var(--app-alm-fault-text-color)';
			if(cls===2) clr='var(--app-alm-warning-text-color)';
			if(cls===1) clr='var(--app-alm-notice-text-color)';
			if(cls===0) clr='var(--app-alm-info-text-color)';

			//menu.setIconColor(k,clr);
			menu.showBadge(k,clr,clr);
			
		}else{
			//menu.setIconColor(k,null);
			menu.hideBadge(k);
		}
	}
}

function update_breadcrumbs(){
	let path=self.breadcrumbs;
	let a=[];
	for(let i=0; i<path?.length; i++){
		let p=path[i];
		a.push(`<a href='${p[1]}'>${p[0]}</a>`);
	}
	dom.breadcrumbs.innerHTML=a.join(' / ');   
	document.title=path[path.length-1][0];
	
}

function cbWorkspaceSrcChanged(){
	
	self.hideModalError();

	let ppath=aWidget.getPath(parent.src);
	let wpath=aWidget.getPath(dom.main_widget.src);
	
	if(wpath!==ppath){
		self.editor_link=undefined;
		pult.hideForm();
		dom.main_widget.src=ppath;
	}
	
	if(Util.isMobile){
		dom.body.classList.add('left_closed');
	}
	
	//refreshSearch();

}

function prepareHTML(){

	dom.main_widget.onload=function (e){
		pult.widget=e.detail;
		pult.widget.main=true;
	}

	dom.body.classList.toggle('mobile',Util.isMobile);
	dom.body.classList.toggle('menu',!pult.user.kiosk_mode);

	if(pult.user.kiosk_mode){
		dom.layout1.restore_case='none';			
		dom.layout2.restore_case='none';			
		dom.layout1.close(1);			
		dom.layout2.close(2);
		if(Util.isMobile) dom.left.style.display='';
	}else{
		dom.layout1.restore_case='always';			
		dom.layout2.restore_case='always';			
		dom.header.style.display='';
		dom.left.style.display='';
		dom.left_icon.style.display='';
		dom.right.style.display='';
	}

	if(config.brand_show_logo){

		dom.brand.style.display='flex';
		let brand_text=config.brand_text;
		if(brand_text) brand_text=brand_text.split('%made_with_pult_online%').join($made_with_pult_online);
	
		if(config.brand_logo==='/html/theme/pult_online_logo.png' || config.brand_logo==='/html/%theme%/pult_online_logo.png'){
			brand_text='';
		}
		
		dom.brand_text.style.display = brand_text ? 'block' : 'none';
		dom.brand_text.innerHTML=brand_text;
		dom.brand_link.href=config.brand_link;
		dom.brand_logo.src=config.brand_logo;
	}

	if(Util.isMobile){

		dom.breadcrumbs.style.display='none';
		
		dom.layout1.closed=0;
		dom.layout2.closed=0;
		
		dom.layout1.restore_case='none';			
		dom.layout2.restore_case='none';
		
		dom.body.classList.add('left_closed');
		dom.body.classList.add('right_closed');
		
		dom.left_icon.onclick=function (e) {
			dom.body.classList.toggle('left_closed');
		}
		
		dom.notification_link.onclick=function (e) {
			dom.body.classList.toggle('right_closed',0);
		}

		dom.right_close.onclick=function (e) {
			dom.body.classList.toggle('right_closed',1);
		}
		
	}else{

		dom.breadcrumbs.style.display='';

		dom.layout1.onclose=refresh_left_closed;
		dom.layout1.onopen=refresh_left_closed;

		dom.layout2.onclose=refresh_right_closed;
		dom.layout2.onopen=refresh_right_closed;

		refresh_left_closed();
		refresh_right_closed();

		dom.left_icon.onclick=function (e) {
			if(dom.layout1.closed){
				dom.layout1.open(1,100);
			}else{
				dom.layout1.close(1,100);
			}
		}

		dom.notification_link.onclick=function (e) {
			dom.layout2.open(2,100);
		}

		dom.right_close.onclick=function (e) {
			dom.layout2.close(2,100);
		}

	}

	


	if(pult.user.anonymous){
		dom.profile_link.style.display='none';
		dom.anonymous_login.style.display='';
	}else{
		dom.profile_link.style.display='';
		dom.anonymous_login.style.display='none';

		let icon=pult.user.icon?pult.user.icon:'/images/user.svg';
		dom.profile_icon.src=icon;
		dom.profile_link.href='#interface/profile';
		dom.profile_text.innerHTML=pult.user.login;
	}

	function refresh_left_closed() {
		dom.body.classList.toggle('left_closed',!!dom.layout1.closed);
	}
	
	function refresh_right_closed() {
		dom.body.classList.toggle('right_closed',!!dom.layout2.closed);
		if(!!dom.layout2.closed){
			dom.notification_link.style.width='';
		}else{
			dom.notification_link.style.width='0px';
		}
	}

	
}



function prepareMenu(){

	menu.css=`.online>.title>.link>.text{color:var(--app-online-color)}.online>.title>.link>a-icon{--color:var(--app-online-color)}.online>.title>.link:hover>.text{color:var(--app-link-hover-color)}.online>.title>.link:hover>a-icon{--color:var(--app-link-hover-color)}.offline>.title>.link>.text{color:var(--app-offline-color)}.offline>.title>.link>a-icon{--color:var(--app-offline-color)}.offline>.title>.link:hover>.text{color:var(--app-link-hover-color)}.offline>.title>.link:hover>a-icon{--color:var(--app-link-hover-color)}`;
	
	if(!pult.user.kiosk_mode){
		menu.onload=function (e){
			let item=e.detail;
			if(item.folder && item.path.startsWith('/projects')){
				loadMenuItem(item.path);
			}
		}
	}

}

function loadMenu(){

	if(!pult.user.kiosk_mode){
		

		menu.onload=function (e){
			let item=e.detail;
			if(!item.path.startsWith('/system')){
				loadMenuItem(item.path);
			}
		}

		pult.loadObject(self,{
			path:'/projects',
			docs:'@prop.json',
			unpack:'@prop.json',
		},function (o){

			menu.addItem({
				path:o._path,
				text:locale_string(o._title),
				icon:o._icon,
				href:o._interface,
				folder:o._count,
				expand:true,
			});

			if(pult.user.admin){

				menu.addItem({
					path:'/system',
					folder:true,
					text:$system,
					icon:'/images/system.svg',
					href:'#interface/system',
					expand:true,
				});
				
				
				let mm=[];
				
				for(let i=0; i<schema.sysmenu.length; i++){
					let m=schema.sysmenu[i];
					mm.push({
						path:m.path,
						text:locale_string(m.text),
						icon:m.icon,
						href:m.href,
					});
				}

				Util.keySort(mm,'text');
				
				for(let i=0; i<mm.length; i++){
					let m=mm[i];
					menu.addItem(m);
				}
				
				
			}
			
			
			if(!pult.user.anonymous){
				
				if(pult.user.editor_access){
					menu.addItem({
						text: $editor,
						href: "#editor/home",
						target: "editor",
						path: "/editor",
						icon: "/images/editor.svg"
					});
				}

				menu.addItem({
					path:'/logout',
					text:$logout,
					icon:'/images/logout.svg',
					onclick:function (){
						pult.showLogout();
					}
				});
			}

		});

		
	}

}

function loadMenuItem(path){
	pult.loadList(self,{
		path:path,
		interface:true,
		inactive:0,
		docs:'@prop.json',
		unpack:'@prop.json'
	},function (oo){
		
		let sv=[];
		
		for(let i=0; i<oo.length; i++){
			let o=oo[i];

			menu.addItem({
				path:o._path,
				text:locale_string(o._title),
				icon:o._icon,
				href:o._interface,
				folder:o._count,
			});
			let ao=pult.userAlarms.objects[o._path];
			if(ao){
				let x={};
				x[o._path]=ao;
				updateTreeBadges(x);
			}

			if(o._status_var) sv.push([o._status_var,o._path]);
	
		}

		pult.subscribeStatusVar(self,sv,function (v,p){
			let mi=menu.getItem(p);		
			if(mi){
				let status=pult.nodeStatuses[v];
				if(status){
					//mi._node.style.setProperty('--text-color',status.color);
					menu.setIconColor(p,status.color);
					menu.setTextColor(p,status.color);
				}else{
					//mi._node.style.setProperty('--text-color','');
					menu.setIconColor(p,null);
					menu.setTextColor(p,null);
				}
				// mi._node.classList.toggle('online',v===true);
				// mi._node.classList.toggle('offline',v===false);
			}
		});


	});
}

function onMetronom(m){
	let snd=false;
	if(pult.sound.enabled && pult.userAlarms && !pult.sound.reset){
		if(pult.userAlarms.summary.actunack){
			snd=m;
		}
	}

	if(snd){
		pult.sound.play('/sound/alarm1.mp3');
	}else{
		pult.sound.stop();
	}

	let upd;
	if(m){
		upd={};
		for(let k in menu.index){
			let o=pult.userAlarms?.objects[k];
			if(o  && o.au[0]){
				upd[k]=o;
			}
		}
	}else{
		upd={};
		for(let k in menu.index){
			let o=pult.userAlarms?.objects[k];
			if(o && o.au[0]){
				upd[k]={
					au:[0,0],
					aa:[0,0],
					iu:[0,0],
				}
			}
		}
	}
	updateTreeBadges(upd);

}